<?
class xar_path {
	public $d = array();
	
	function __construct($d) {
		if( is_array($d) ) $this->d = $d;
		elseif( substr($d, 0,2) == "M " ) $this->d = explode(" ", $d);
	}

	function printXml() {
		if( sizeof($this->d) == 0 ) die("ERROR: No path data");
		return implode(" ", $this->d);
	}

	// Pevede na absolutn souadnice
	function toAbsolute()
	{
		$x = $this->d[1];
		$y = $this->d[2];
		$i = 3;
		while( $i < sizeof($this->d) ) {
			$x = $this->d[$i+1] = $x - $this->d[$i+1];
			$y = $this->d[$i+2] = $y - $this->d[$i+2];
			$i += 3;
		}
	}

	function relative()
	{
		$i = 0;
		while( $i < sizeof($this->d) ) {
			switch( $this->d[$i] ) {
				case 'C':
				case 'L':
				case 'M':
					if( $i == 0 )
					{
						$x = $this->d[$i+1];
						$y = $this->d[$i+2];
					}
					else
					{
						$nx = $this->d[$i+1];
						$ny = $this->d[$i+2];
						$this->d[$i+1] = $x-$this->d[$i+1];
						$this->d[$i+2] = $y-$this->d[$i+2];
						$x = $nx;
						$y = $ny;
					}
					$i += 3;
				break;
				default:
					print_r($this->d);
					die("\nChyba: relative() Spatne zadana cesta ($this->d[$i])");
			}
		}
	}
	
	function getBinaryString() {
		$bin = "";
		$i = 0;
		while( $i < sizeof($this->d) ) {
			if( $this->d[$i] == 'L' ) $bin .= chr(LINETO);
			elseif( $this->d[$i] == 'M' ) $bin .= chr(MOVETO);
			else $bin .= chr(CURVETO);
			$i++;

			$x = pack('l', $this->d[$i++]);
			$y = pack('l', $this->d[$i++]);
			$coords = $x[3].$y[3].$x[2].$y[2].$x[1].$y[1].$x[0].$y[0];
			$bin .= $coords;
		}
		return $bin;
	}

	function putCoord($x, $y) {
		$x = pack('l', $x);
		$y = pack('l', $y);
		$coord = $x[3].$y[3].$x[2].$y[2].$x[1].$y[1].$x[0].$y[0];
		return $coord;
	}
}
?>
